Subject: Re: [netconf] Capability-fetching mechanisms

From: Qin Wu <[email-masked]>
Date: Thu, 13 May 2021 08:27:21 +0000

发件人: Mahesh Jethanandani [mailto:[email-masked]]
发送时间: 2021年5月13日 8:13
收件人: Qin Wu <[email-masked]>
抄送: Kent Watsen <[email-masked]>; [email-masked]
主题: Re: [netconf] Capability-fetching mechanisms

Hi Qin,

When Kent and I started working on the HTTPs notif draft we wanted to make sure that it was lightweight as it relates to setting it up. That means that if the publisher and receiver are HTTPS capable, that in most cases that is all that isneeded to establish the notification channel. To quite an extent that is still true. With default values (JSON encoding), one can setup a HTTPS notification channel by configuring the *publisher* where the receiver resides (its IP address) and any credentials that are needed to setup the channel. The receiver does not need to be configured, and as such does not need to be a NETCONF/RESTCONF server (or a client for that matter).

[Qin]: Thanks for your clarification, I think in appendix using subscribed notification and not using subscribed notification are both supported.
In the case of using subscribed notification, RFC8639 enabled capability is supported while in the case without using subscribed notification, RFC8639 enabled capability is not supported?
In the first case, the publisher need to be NETCONF/RESTCONF server? In the second case, it is not. Right?

Cheers.

On May 11, 2021, at 6:51 PM, Qin Wu <[email-masked]<mailto:[email-masked]>> wrote:

Hi, Kent:
Sorry for late follow up.
On Apr 19, 2021, at 5:39 PM, Kent Watsen <[email-masked]<mailto:[email-masked]>> wrote:

Dear WG,

One of the outcomes from “https-notif” presentation during the NETCONF 110 session was to what extent all the notif (e.g., https, udp, etc.) drafts should define their own capability-fetching mechanism, or use the mechanism defined by the "data-export-capabilities” draft.

As authors, Mahesh and I discussed some of the PROs and CONs of the approaches as follows:
[Qin]:I am under impression that shared-mechanism has a lot of benefit.:-)

  *   PROs (for having a shared-mechanism):

     *   Enables a common mechanism spanning multiple notif transports to exist

  *   CONs (against having a shared mechanism):

     *   Entails each receiver also needing to be a NETCONF and/or RESTCONF server
                                [Qin]:Is receiver in this context NETCONF/RESTCONF server or client?
                                  I think we mix two things,
a.       one is the server advertise its capability to the client , (i.e., server capability advertisement)
b.       the other is server send the capability query request the client and get capability response from the client. (client capability fetching)
                                I think data-export-capabilities right now focuses on (a), the question you ask here is whether (b) can be defined as shared mechanism which can be part of
                                the "data-export-capabilities” draft. If my understanding is correct, I think it will be nice to have (b) such shared mechanism, i.e., Defining (a) and (b) in a single place.

        *   Whereas a notif-specific solution can be optimized on a per-protocol basis.
        *   FWIW, if RC, the receiver COULD minimally support *just* the single GET request (i.e., not a complete RC server)
        *   Still, networking/firewall would have to support the outbound NC/RC flow, in addition to the base notification flow
                   [Qin]: "data-export-capabilities " draft uses draft-ietf-netconf-notification-capabilities-16 as basis or foundation. If my understanding is correct, draft-ietf-netconf- notification-capabilities-16 doesn’t
require receiver to support NETCONF or   RESTCONF.

     *   Potentially extends the number of capabilities to be more than minimally necessary

        *   e.g., the current "data-export-capabilities” modules define dozens of capabilities supporting RFC 8639 and RFC 8641 that are not needed for https-notif,
                                     [Qin] Dozens of capabilities defined by the current "data-export-capabilities” modules are all optional capability. It doesn’t require all the capabilities to be supported.
when RFC 8639 is not in use.

           *   HTTPS-Notif seems to need only three capabilities:

              *   What encodings are supported (json, xml, binary)
              *   If the RFC 8639 state machine is supported.
              *   If bundled messages is supported.
                                  [Qin]: So HTTPs-notif can pick those three capabilities and ignore other capabilities.  I believe HTTP has mechanism to deal with these unhandled capabilities advertised by the network device.  One of such example is unhandled
Namespace defined in (https://datatracker.ietf.org/doc/html/draft-ietf-regext-unhandled-namespaces-07)

           *   Presumably, UDP-Notif would similarly have a small set of capacities.

              *   In fact, it may be less, as UDP may be unable to support RFC 8639
             [Qin]: See clarification above. For UDP notif, it doesn’t require all the capability to be supported.

Thoughts?

Kent and Mahesh  // as authors

_______________________________________________
netconf mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/netconf

_______________________________________________
netconf mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/netconf

Mahesh Jethanandani
[email-masked]<mailto:[email-masked]>

---

From: Mahesh Jethanandani <[email-masked]>
Date: Mon, 17 May 2021 14:47:46 -0700

Hi Qin,

> On May 13, 2021, at 1:27 AM, Qin Wu <[email-masked]> wrote:
> 
> 发件人: Mahesh Jethanandani [mailto:[email-masked] <mailto:[email-masked]>] 
> 发送时间: 2021年5月13日 8:13
> 收件人: Qin Wu <[email-masked] <mailto:[email-masked]>>
> 抄送: Kent Watsen <[email-masked] <mailto:[email-masked]>>; [email-masked] <mailto:[email-masked]>

[mj] The fact that the publisher has to be a NETCONF/RESTCONF server was never in dispute. The question is whether the receiver needs to be a NETCONF/RESTCONF server. As maqiufang wrote in his response, if the receiver supports the data-export-capabilities draft, then it would need to be a NETCONF/RESTCONF server, whereas with the https-notif draft that is not the case. This is the case whether the receiver supports RFC 8639 or not.

Please note that RFC 8639 receivers do not have to be NETCONF/RESTCONF servers for configured subscriptions. RFC 8639, Section 2.7 defines the control messages such as <subscription-started> using one-way YANG “notification” statements.

Thanks

>  
> Cheers.
> 
> 
> On May 11, 2021, at 6:51 PM, Qin Wu <[email-masked] <mailto:[email-masked]>> wrote:
>  
> Hi, Kent:
> On Apr 19, 2021, at 5:39 PM, Kent Watsen <[email-masked] <mailto:[email-masked]>> wrote:
>  
> Dear WG,
>  
> PROs (for having a shared-mechanism):
> Enables a common mechanism spanning multiple notif transports to exist 
> CONs (against having a shared mechanism):
> Entails each receiver also needing to be a NETCONF and/or RESTCONF server
> Whereas a notif-specific solution can be optimized on a per-protocol basis.
> FWIW, if RC, the receiver COULD minimally support *just* the single GET request (i.e., not a complete RC server)
> Still, networking/firewall would have to support the outbound NC/RC flow, in addition to the base notification flow
> Potentially extends the number of capabilities to be more than minimally necessary
> e.g., the current "data-export-capabilities” modules define dozens of capabilities supporting RFC 8639 and RFC 8641 that are not needed for https-notif,
> HTTPS-Notif seems to need only three capabilities:
> What encodings are supported (json, xml, binary)
> If the RFC 8639 state machine is supported.
> If bundled messages is supported.
> Namespace defined in (https://datatracker.ietf.org/doc/html/draft-ietf-regext-unhandled-namespaces-07 <https://datatracker.ietf.org/doc/html/draft-ietf-regext-unhandled-namespaces-07>)
> Presumably, UDP-Notif would similarly have a small set of capacities.
> In fact, it may be less, as UDP may be unable to support RFC 8639
> [email-masked] <mailto:[email-masked]>
> https://www.ietf.org/mailman/listinfo/netconf <https://www.ietf.org/mailman/listinfo/netconf>
>  
> [email-masked] <mailto:[email-masked]>
> https://www.ietf.org/mailman/listinfo/netconf <https://www.ietf.org/mailman/listinfo/netconf>
>  
> Mahesh Jethanandani
> [email-masked] <mailto:[email-masked]>
>  
>  
>  
> 
>  

Mahesh Jethanandani
[email-masked]